       program     S12KSI
C
C Four-state-Ketosteroid-isomerase-enzyme-kinetic-scheme (KSI-enzyme)
C
C Toney-2019, Hawkinson-1991, Pollack-1989
C
C About 50% of all initiated variables are not used in this program
C
       real*8  ckonst1a(1000),enprodL,lighti,axhL,currL,
     &   ckonst2a(1000),ckonstd,photone,thermale,rckonst1,rckonst2,
     &   rlighti,aoc,xsec,sigma,uredx,currD,enprodD,enprodB1,
     &   enprodB2,apexpD,apexpch,apchp,acmidpo,donmidpo,axhB,
     &   enprodO,enprodI,enprodH,effic,rckonstd,k12,ckonst2o,
     &   tameB2,k21,tameB1,ckonst1o,ckonst2i(50),enB1max,
     &   k23,k32,k34,k43,k41,k14,keqk12,keqk23,keqk34,keqk41,
     &   ckonst1i(50),tameOUT,efficOUT,efficopt,enTopt,enB2max,
     &   ck3,rck3,ck4,rck4,ckslip,rckslip,sigmapex,sigmap,sigmab,
     &   sigmah,sigmaq,currB1,currB2,currB3,currB4,currSLIP,
     &   enprodS,enprodB3,enprodB4,apexB,abh,ahq,aqp,ahp,currC,
     &   ckonst3o,ckonst4o,enB3max,enB4max,tameB3,tameB4,
     &   ckonst3a(1000),ckonst4a(1000),ckonst3i(50),ckonst4i(50),
     &   ckonstda(1000),keqslip,keqk3,keqk1,keqk2,keqk4,
     &   ckonst5a(1000),ckonst5i(1000),ckonst5o,tameB5,enB5max,
     &   kike,effic3,effic4,effico3,effico4,effico3i(50),
     &   effico4i(50),effic5,effico5,effico5i(50),effico1i(50),
     &   slipout,xsecsh,xsecshli,trinv,
     &   sigmaopt,sigmapop,enprodT,
     &   sigmapxo,sigmabop,sigmahop,sigmaqop,
     &   sprob(4),entros(4),entrops,
     &   aX1,aX2,aX3,aX4,s1,s2,pi,gaussrand,
     &   currB1opt,currB2opt,currB3opt,
     &   enprodB1opt,enprodB2opt,enprodB3opt,
     &   kcat,KMich,Ktot,ENZeff,substrates,products,
     &   kcatopt,KMichopt,ENZeffopt,aX
C
       sigmaopt=0.0
       sigmapxo=0.0
       sigmapop=0.0
       sigmabop=0.0
       sigmahop=0.0
       sigmaqop=0.0
       currB1opt=0.0
       currB2opt=0.0
       currB3opt=0.0
       enprodB1opt=0.0
       enprodB2opt=0.0
       enprodB3opt=0.0
       kcatopt=0.0
       KMichopt=0.0
       ENZeffopt=0.0
       trinv=0.0
       xsecsh=0.0
       slipout=0.0
       xsecshli=0.0
       keqslip=0.0
       keqk3=0.0
       keqk1=0.0
       keqk4=0.0
       keqk2=0.0
       keqk12=0.0
       keqk23=0.0
       keqk34=0.0
       keqk41=0.0
       kike=0.0
       ahp=0.0
       aqp=0.0
       ahq=0.0
       aX1=0.0
       aX2=0.0
       aX3=0.0
       aX4=0.0
       aX=0.0
       apexB=0.0
       enprodB3=0.0
       enprodB4=0.0
       enprodS=0.0
       enprodB1=0.0
       enprodB2=0.0
       enprodT=0.0
       enB4max=0.0
C add.
       enprodD=0.0
       enprodL=0.0
C
       sigmapex=0.0
       sigmap=0.0
       sigmab=0.0
       sigmah=0.0
       sigmaq=0.0
C       emprodL=0.0
C       emprodD=0.0
       tameB2=0.0
       tameB1=0.0
       tameB4=0.0
       tameB3=0.0
       tameB5=0.0
       tameOUT=0.0
       efficopt=0.0
       efficOUT=0.0
       effic3=0.0
       effic4=0.0
       effic5=0.0
       effico3=0.0
       effico4=0.0
       effico5=0.0
       enB1max=0.0
       enB2max=0.0
       enB3max=0.0
       enB4max=0.0
       enB5max=0.0
       enTopt=0.0
       ckonst2o=0.0
       ckonst1o=0.0
       ckonst4o=0.0
       ckonst3o=0.0
       ckonst5o=0.0
       emprodB1=0.0
       emprodB2=0.0
       k12=0.0
       k21=0.0
       k23=0.0
       k32=0.0
       k34=0.0
       k43=0.0
       k41=0.0
       k14=0.0
       substrates=0.0004
       products=0.0004
       currB1=0.0
       currB2=0.0
       currB3=0.0
       currB4=0.0
       currSLIP=0.0
       currC=0.0
       currL=0.0
       currD=0.0
       axhL=0.0
       axhB=0.0
       apexpD=0.0
       apexpch=0.0
       apchp=0.0
       ckonstd=0.0
C add:
       rckonstd=0.0
C
       photone=0.0
       thermale=0.0
       lighti=0.0
       rckonst1=0.0
       rckonst2=0.0
       ck3=0.0
       rck3=0.0
       ck4=0.0
       rck4=0.0
       ckslip=0.0
       rckslip=0.0
       rlighti=0.0
       aoc=0.0
       xsec=0.0
       uredx=0.0
       sigma=0.0
       acmidpo=0.0
       donmidpo=0.0
       enprodO=0.0
       enprodI=0.0
       enprodH=0.0
       effic=0.0
C
       kcat=0.0
       KMich=0.0
       ENZeff=0.0
       Ktot=0.0
C
       s1=0.0
       s2=0.0
       pi=0.0
       gaussrand=0.0
C add:
       mmm=0
       i=0
       entrops=0.0
C
       nnn=0
       jjj=0
       do 25 j=1,1000
       ckonst1a(j)=0.0
       ckonst2a(j)=0.0
       ckonst3a(j)=0.0
       ckonst4a(j)=0.0
       ckonstda(j)=0.0
       ckonst5a(j)=0.0
C
25     continue
       do 30 ll=1,50
       ckonst1i(ll)=0.0
       ckonst2i(ll)=0.0
       ckonst3i(ll)=0.0
       ckonst4i(ll)=0.0
       ckonst5i(ll)=0.0
       effico1i(ll)=0.0
       effico3i(ll)=0.0
       effico4i(ll)=0.0
       effico5i(ll)=0.0
30     continue
C
       substrates=0.0001
       products=0.00005
C      in moles
C      Kinetic constants without [S] and [P] are from Toney-2019
C
       k12=830000000.0*substrates
       k21=86000.0
       k23=180000.0
       k32=1700000.0
       k34=640000.0
       k43=43.0
       k41=150000.0
       k14=1000000000.0*products
C
       keqk23=0.10588235
       keqk34=14883.72093
       keqk41=0.000375
       keqk41=k41/k14
   	   keqk12=k12/k21
C
C As in all other programs calculate RT in kJ per mol, but use 25C instead of 20C
            thermale=2.478957
C
         pi=3.141592653589793
C
        do 215 lll=1,2
       tameB2=0.0
       tameB1=0.0
       tameB3=0.0
       tameB4=0.0
C
          if (lll.eq.2) then
        open (unit=9,status='unknown',file='S12KSI-randk1.dat',
     & access='sequential',form='formatted')
       write(9,45)
45     format(2x,' step       k1          k2           k3      ',
     & '       k4          k5           k6         k7            k8 ',
     & '         Ptot           Eff             kcat      ',
     & '    Km            P1         P2       P3           P4     ',
     & '      J                S(I)        p1            p2        ',
     & '     p3          p4          Ktot          X')
          endif
C
        do 50 i=1,1000
C
        call random_number(s1)
        call random_number(s2)
C
        gaussrand=sqrt(-2*2.3025851*dlog10(s1))*cos(2*pi*s2)+2.0
C
        if(gaussrand.gt.0) then
C
       ckonst4a(i)=150000
C
         k41=ckonst4a(i)
C
         k14=k41/keqk41
C
       ckonst3a(i)=640000
         k34=ckonst3a(i)
         k43=k34/keqk34
       ckonst2a(i)=180000
         k23=ckonst2a(i)
         k32=k23/keqk23
C For k12 the substrate conc. 0.0001 moles s taken into account
C
       ckonst1a(i)=83000*gaussrand
         k12=ckonst1a(i)
C
          k21=86000.0
          keqk12=k12/k21
C
          endif
C
       kcat=(k23*k34*k41)/((k23+k32)*(k43+k41)+k23*k34+k34*k41)
C
       Ktot=keqk12*keqk23*keqk34*keqk41
C
       KMich=(k21*(k32*(k43+k41)+k34*k41)+k23*k34*k41)*substrates/
     &       (k12*((k23+k32)*(k43+k41)+k23*k34+k34*k41))
C
        ENZeff=kcat/KMich
C
         sigma=0.0
         sigmab=0.0
         sigmah=0.0
         sigmaq=0.0
         sigmap=0.0
C 4-th state probability added p=1,b=2,h=3,q=4
         entrops=0.0
	   enprodB1=0.0
	   enprodB2=0.0
	   enprodB3=0.0
       enprodB4=0.0
	   enprodT=0.0
C
           do 55 jj=1,4
         sprob(jj)=0.0
         entros(jj)=0.0
55       continue
C
         sigmap=k43*k32*k21+k21*k34*k41+k41*k32*k21+k23*k34*k41
         sigmab=k34*k41*k12+k14*k43*k32+k12*k43*k32+k32*k41*k12
         sigmah=k41*k12*k23+k21*k14*k43+k14*k43*k23+k12*k23*k43
         sigmaq=k32*k21*k14+k12*k23*k34+k14*k23*k34+k21*k14*k34
C
C
         sigma=sigmab+sigmah+sigmaq+sigmap
C
         sigmab=sigmab/sigma
         sigmah=sigmah/sigma
         sigmaq=sigmaq/sigma
         sigmap=sigmap/sigma
C
         sprob(1)=sigmab
         sprob(2)=sigmah
         sprob(3)=sigmaq
         sprob(4)=sigmap
C
       do 700 mmmm=1,4
          entros(mmmm)=-sprob(mmmm)*2.3*dlog10(sprob(mmmm))
          entrops=entrops+entros(mmmm)
700    continue
C
C
       xsec=thermale*2.3025851*dlog10((k12*k23*k34*k41)/
     & (k21*k32*k43*k14))
Cn all currents are without N (N=1)
Cn
        currB1=(k12*sigmap-k21*sigmab)
        currB2=(k23*sigmab-k32*sigmah)
        currB3=(k34*sigmah-k43*sigmaq)
        currB4=(k41*sigmaq-k14*sigmap)
C
          aX1=2.3025851*dlog10((k12*sigmap)/
     &   (k21*sigmab))
C
          aX2=2.3025851*dlog10((k23*sigmab)/
     &   (k32*sigmah))
C
          aX3=2.3025851*dlog10((k34*sigmah)/
     &   (k43*sigmaq))
C
          aX4=2.3025851*dlog10((k41*sigmaq)/
     &   (k14*sigmap))
C
          aX=aX1+aX2+aX3+aX4
C
        enprodB1=aX1*currB1
        enprodB2=aX2*currB2
        enprodB3=aX3*currB3
        enprodB4=aX4*currB4
C
        enprodT=enprodB1+enprodB2+enprodB3+enprodB4
C
C These enprod values are entropy production divided by the gas constant R
C Thus, units are in inverse seconds
C
        tameB4=max(enprodB4,tameB4)
         if (tameB4.eq.enprodB4) then
            mmm=i
            enB4max=enprodB4
            sigmaopt=sigma
            sigmabop=sigmab
            sigmahop=sigmah
            sigmaqop=sigmaq
            sigmapop=sigmap
            enTopt=enprodT
C
            currB1opt=currB1
            currB2opt=currB2
            currB3opt=currB3
            currB4opt=currB4
            enprodB1opt=enprodB1
            enprodB2opt=enprodB2
            enprodB3opt=enprodB3
C
            kcatopt=kcat
            KMichopt=KMich
            ENZeffopt=ENZeff
C
         endif
C
        if (lll.eq.2) then
       write(9,'(i6,8(f12.1,1x),3(f14.2,1x),1x,f9.6,1x,12(f12.5,1x))')
     &  i,k12,k21,k23,k32,k34,k43,k41,k14,enprodT,ENZeff,kcat,KMich,
     &  enprodB1,enprodB2,enprodB3,enprodB4,
     &  currB1,entrops,sigmap,sigmab,sigmah,sigmaq,keqk41,aX
        endif
C
 50    continue
C

       close(unit=9)
C
C        pause
215     continue
250     continue
        open (unit=3,status='unknown',file='iterKSI.dat',
     & access='sequential',form='formatted')
C
       write(3,'(f20.18,1x,f20.18,1x,f20.18,1x,f20.18)')
     &  sigmapop,sigmabop,sigmahop,sigmaqop
C
C
       write(3,'(1x,12(f10.5,1x),1x,f12.8,1x,f12.3)')
     &  enprodB1opt,enprodB2opt,enprodB3opt,enB4max,enTopt,entrops,
     &  currB1opt,currB2opt,currB3opt,currB4opt,
     &  xsec,kcatopt,KMichopt,ENZeffopt
C
        close(unit=3)
C
C
       stop
       end
C
C Author: Davor Juretic, year:2023, preprint:
C Computational Improvements of Enzyme Efficiency kcat/KM by Increasing Noise and Dissipation
C Submitted to the Entropy journal.
C Title: Theoretical Improvements in Enzyme Efficiency Associated with Noisy Rate Constants and Increased Dissipation
C This source code produce S12KSI-randk1.dat parameters for random changes in k1 rate constant.
C We used the columns enprodT (named Ptot) and ENZeff (named Eff)
C to create figure S6 from the Supplementary Materials.
C The run time should be around 1.0 sec.
C
